\ ========================================================================================
\ Patch pci-pci-config to probe device numbers up to 0x1F instead of just 0x0F.

\ ========================================================================================
\ version 1 for Open Firmware 1.0.5 
\ The fcode is in ROM so copy the page we want to patch to RAM.
\ pros: Patches fcode instead of words so it's done only once.
\ cons: Requires virtual memory which takes more code to setup.

0 value iu
0 value im
0 value ch
: gp ch get-package-property drop decode-int ;
" /chosen" find-package drop to ch
" mmu" gp to iu 2drop
" memory" gp to im 2drop
: cm $call-method ;
: cv " claim" iu cm ;
: cp " claim" im cm ;
: mp " map" iu cm ;
: ump " unmap" iu cm ;
-B8000 value vr
1000 value sz
sz sz cv value vn
sz sz cp value ph
ph vn sz 10 mp
vr vn sz move
-400000 400000 ump
-400000 -400000 348000 0 mp
ph vr sz 10 mp
-B7000 -B7000 B7000 0 mp
vn sz ump
vn sz " release" iu cm
445 get-token drop execute \ kill-bat3
57B FFF487A5 w!

\ ========================================================================================
\ version 2 for Open Firmware 1.0.5
\ The fcode is in ROM so patch b(;)
\ pros: This version doesn't use virtual memory so it's much shorter.
\ cons: Patches b(;) so it's not as fast.

20 constant h#20
: pppc last@ dup @ + 6 + " "(0E1709)config-l!" comp 0=
last@ f8 + @ ff0 = and
if last@ 184 + ['] h#20 blpatch then ;
c2 get-token drop c + ' pppc 8 + brpatch

\ 90744: FF864AB0: FFFF FFD0     FF864A80                                                           "...–"
\ ...
\ 90804: FF864BA8: 0000 0FF0                       dc.l     0xFF0                                   "..."
\ ...
\ 90839: FF864C34: 4BFA 7B3D     FF80C770          bl       mac_rom_constant_4F7_10                 "K˙{="

\ ========================================================================================
\ version 3 for Open Firmware 1.0.5
\ The fcode is in ROM so patch b(;)
\ pros: Only has one compare.
\ cons: Patches b(;) so it's not as fast.
\ fcode 4E4 is `fc-addr which points to the next fcode to execute

20 constant h#20
defer `f 4E4 get-token drop to `f
: pppc `f @ FFF4884D = if
last@ 184 + ['] h#20 blpatch then ;
c2 get-token drop c + ' pppc 8 + brpatch

\ ========================================================================================
\ version for Open Firmware 3.1.1
\ The fcode is in RAM so just change it.

5C5 002417B2 w!
5C5 002418FF w!

\ ========================================================================================
\ ========================================================================================
\ Dump the fcode image list for Open Firmware 3.1.1

install-console
7fffffff to lines/page

dev /@0/@0
.properties
unselect-dev

@startvec 90 + @ \ >fcfiles
begin dup 10 dump dup @ while dup @ + repeat
drop
cr

." [ probe-all" cr
probe-all
." ] probe-all" cr
banner


\ ================================

00243320: ff ff e6 a0 06 46 10 95 ff ff ff ff 00 00 00 00 :.....F..........:
002419c0: ff ff f9 f8 ff ff ff ff 00 0c 03 10 00 00 00 00 :................:
002413b8: ff ff 9d d8 ff ff ff ff 00 06 04 00 00 00 00 00 :................:
0023b190: ff ff f2 88 ff ff ff ff 00 00 00 0b 00 00 00 00 :................:
0023a418: ff ff f8 b0 ff ff ff ff 00 00 00 0a 00 00 00 00 :................:
00239cc8: ff ff fb d8 ff ff ff ff 00 00 00 07 00 00 00 00 :................:
002398a0: ff ff dd 78 ff ff ff ff 00 00 00 06 00 00 00 00 :...x............:
00237618: ff ff ed d0 ff ff ff ff 00 00 00 05 00 00 00 00 :................:
002363e8: ff ff fa 40 ff ff ff ff 00 00 00 04 00 00 00 00 :...@............:
00235e28: ff ff fd 60 ff ff ff ff 00 00 00 03 00 00 00 00 :...`............:
00235b88: 00 00 00 00 ff ff ff ff 00 00 00 02 00 00 00 00 :................:

\ ========================================================================================
" pci/@D/@2/@0/@10/@0/@0" 2dup find-device open-dev dup . to my-self
" pci/@D/@2/@0/@10/@0/@1" 2dup find-device open-dev dup . to my-self
10 20 20 40 40 fill-rectangle
